import {makeAutoObservable} from "mobx";
import {http} from "../utils/http";

export class Role {
    page = null;
    pageSize = null;
    data = [];
    total_data = 0

    constructor(ctx) {
        this.ctx = ctx;
        makeAutoObservable(this);
    }

    async getData() {
        const response = await http.get(`/config/roles?page=${this.page}&pageSize=${this.pageSize}`);
        this.data = response.body.data ?? []
        this.total_data = response.body.total_data ?? 0
    }

    async create(data) {
        return await http.post('/users').send(data)
    }

    async update(id, data) {
        return await http.put('/users/' + id).send(data);
    }

    async delete(id) {
        return await http.del('/users/' + id);
    }
}


